## tree-sitter-asm 0.24.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

project(tree-sitter-asm
        VERSION "0.1.0"
        DESCRIPTION "assembly grammar for tree-sitter"
        HOMEPAGE_URL "https://github.com/RubixDev/tree-sitter-asm"
        LANGUAGES C)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(TREE_SITTER_REUSE_ALLOCATOR "Reuse the library allocator" OFF)

set(TREE_SITTER_ABI_VERSION 14 CACHE STRING "Tree-sitter ABI version")
if(NOT ${TREE_SITTER_ABI_VERSION} MATCHES "^[0-9]+$")
    unset(TREE_SITTER_ABI_VERSION CACHE)
    message(FATAL_ERROR "TREE_SITTER_ABI_VERSION must be an integer")
endif()

find_program(TREE_SITTER_CLI tree-sitter DOC "Tree-sitter CLI")

add_custom_command(OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/src/parser.c"
                   DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/grammar.json"
                   COMMAND "${TREE_SITTER_CLI}" generate src/grammar.json
                            --abi=${TREE_SITTER_ABI_VERSION}
                   WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                   COMMENT "Generating parser.c")

add_library(tree-sitter-asm src/parser.c)
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/src/scanner.c)
  target_sources(tree-sitter-asm PRIVATE src/scanner.c)
endif()
target_include_directories(tree-sitter-asm PRIVATE src)

target_compile_definitions(tree-sitter-asm PRIVATE
                           $<$<BOOL:${TREE_SITTER_REUSE_ALLOCATOR}>:TREE_SITTER_REUSE_ALLOCATOR>
                           $<$<CONFIG:Debug>:TREE_SITTER_DEBUG>)

set_target_properties(tree-sitter-asm
                      PROPERTIES
                      C_STANDARD 11
                      POSITION_INDEPENDENT_CODE ON
                      SOVERSION "${TREE_SITTER_ABI_VERSION}.${PROJECT_VERSION_MAJOR}"
                      DEFINE_SYMBOL "")

configure_file(bindings/c/tree-sitter-asm.pc.in
               "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-asm.pc" @ONLY)

include(GNUInstallDirs)

install(FILES bindings/c/tree-sitter-asm.h
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/tree_sitter")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tree-sitter-asm.pc"
        DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig")
install(TARGETS tree-sitter-asm
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

add_custom_target(ts-test "${TREE_SITTER_CLI}" test
                  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
                  COMMENT "tree-sitter test")

=== Makefile ===
ifeq ($(OS),Windows_NT)
$(error Windows is not supported)
endif

LANGUAGE_NAME := tree-sitter-asm
HOMEPAGE_URL := https://github.com/RubixDev/tree-sitter-asm
VERSION := 0.1.0

# repository
SRC_DIR := src

TS ?= tree-sitter

# install directory layout
PREFIX ?= /usr/local
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
PCLIBDIR ?= $(LIBDIR)/pkgconfig

# source/object files
PARSER := $(SRC_DIR)/parser.c
EXTRAS := $(filter-out $(PARSER),$(wildcard $(SRC_DIR)/*.c))
OBJS := $(patsubst %.c,%.o,$(PARSER) $(EXTRAS))

# flags
ARFLAGS ?= rcs
override CFLAGS += -I$(SRC_DIR) -std=c11 -fPIC

# ABI versioning
SONAME_MAJOR = $(shell sed -n 's/\#define LANGUAGE_VERSION //p' $(PARSER))
SONAME_MINOR = $(word 1,$(subst ., ,$(VERSION)))

# OS-specific bits
ifeq ($(shell uname),Darwin)
	SOEXT = dylib
	SOEXTVER_MAJOR = $(SONAME_MAJOR).$(SOEXT)
	SOEXTVER = $(SONAME_MAJOR).$(SONAME_MINOR).$(SOEXT)
	LINKSHARED = -dynamiclib -Wl,-install_name,$(LIBDIR)/lib$(LANGUAGE_NAME).$(SOEXTVER),-rpath,@executable_path/../Frameworks
else
	SOEXT = so
	SOEXTVER_MAJOR = $(SOEXT).$(SONAME_MAJOR)
	SOEXTVER = $(SOEXT).$(SONAME_MAJOR).$(SONAME_MINOR)
	LINKSHARED = -shared -Wl,-soname,lib$(LANGUAGE_NAME).$(SOEXTVER)
endif
ifneq ($(filter $(shell uname),FreeBSD NetBSD DragonFly),)
	PCLIBDIR := $(PREFIX)/libdata/pkgconfig
endif

all: lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT) $(LANGUAGE_NAME).pc

lib$(LANGUAGE_NAME).a: $(OBJS)
	$(AR) $(ARFLAGS) $@ $^

lib$(LANGUAGE_NAME).$(SOEXT): $(OBJS)
	$(CC) $(LDFLAGS) $(LINKSHARED) $^ $(LDLIBS) -o $@
ifneq ($(STRIP),)
	$(STRIP) $@
endif

$(LANGUAGE_NAME).pc: bindings/c/$(LANGUAGE_NAME).pc.in
	sed -e 's|@PROJECT_VERSION@|$(VERSION)|' \
		-e 's|@CMAKE_INSTALL_LIBDIR@|$(LIBDIR:$(PREFIX)/%=%)|' \
		-e 's|@CMAKE_INSTALL_INCLUDEDIR@|$(INCLUDEDIR:$(PREFIX)/%=%)|' \
		-e 's|@PROJECT_DESCRIPTION@|$(DESCRIPTION)|' \
		-e 's|@PROJECT_HOMEPAGE_URL@|$(HOMEPAGE_URL)|' \
		-e 's|@CMAKE_INSTALL_PREFIX@|$(PREFIX)|' $< > $@

$(PARSER): $(SRC_DIR)/grammar.json
	$(TS) generate $^

install: all
	install -d '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter '$(DESTDIR)$(PCLIBDIR)' '$(DESTDIR)$(LIBDIR)'
	install -m644 bindings/c/$(LANGUAGE_NAME).h '$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h
	install -m644 $(LANGUAGE_NAME).pc '$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc
	install -m644 lib$(LANGUAGE_NAME).a '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a
	install -m755 lib$(LANGUAGE_NAME).$(SOEXT) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR)
	ln -sf lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT)

uninstall:
	$(RM) '$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).a \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXTVER_MAJOR) \
		'$(DESTDIR)$(LIBDIR)'/lib$(LANGUAGE_NAME).$(SOEXT) \
		'$(DESTDIR)$(INCLUDEDIR)'/tree_sitter/$(LANGUAGE_NAME).h \
		'$(DESTDIR)$(PCLIBDIR)'/$(LANGUAGE_NAME).pc

clean:
	$(RM) $(OBJS) $(LANGUAGE_NAME).pc lib$(LANGUAGE_NAME).a lib$(LANGUAGE_NAME).$(SOEXT)

test:
	$(TS) test

.PHONY: all install uninstall clean test

=== debian/changelog ===
tree-sitter-asm (0.24.0-2) unstable; urgency=medium

  [ James McCoy ]
  * Generate parser using the same language ABI as upstream's release

  [ Matthias Geiger ]
  * d/control: Drop obsolete Rules-Require-Root field
  * d/watch: Switch to v5

  [ Antonin Delpeuch ]
  * Fix typo in d/control

 -- Matthias Geiger <werdahias@debian.org>  Tue, 14 Oct 2025 11:56:44 +0200

tree-sitter-asm (0.24.0-1) experimental; urgency=medium

  * New upstream release
  * d/patches: Refresh; drop fix-build patch
  * d/control: Update B-D and Provides: for new upstream
  * d/Makefile.in: Delete erroneous scanner.c entry
  * d/t/control: Re-enable smoke test
  * d/t/control: Update rust autopkgtest
  * d/salsa-ci.yml: Skip blhc

 -- Matthias Geiger <werdahias@debian.org>  Sun, 29 Jun 2025 19:36:16 +0200

tree-sitter-asm (0.22.6-1) experimental; urgency=medium

  * Initial release. (Closes: #1102093)

 -- Matthias Geiger <werdahias@debian.org>  Sun, 18 May 2025 21:26:25 +0200

=== debian/control ===
Source: tree-sitter-asm
Priority: optional
Maintainer: Tree-sitter Team <team+tree-sitter@tracker.debian.org>
Uploaders: Matthias Geiger <werdahias@debian.org>
Build-Depends:
 cargo:native,
 debhelper-compat (= 13),
 dh-sequence-rust,
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev,
 librust-tree-sitter-0.25+default-dev (>= 0.25.0-~~),
 nodejs,
 rustc:native,
 tree-sitter-cli (>= 0.25),
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/RubixDev/tree-sitter-asm/
Vcs-Git: https://salsa.debian.org/tree-sitter-team/tree-sitter-asm.git
Vcs-Browser: https://salsa.debian.org/tree-sitter-team/tree-sitter-asm

Package: tree-sitter-asm-src
Architecture: all
Depends:
 ${misc:Depends},
 gcc,
 libc6-dev | libc-dev,
 libtree-sitter-dev (>= 0.25),
 make,
 pkgconf,
Description: ASM parser for Tree-sitter (source files)
 This package contains the generated source files for building the ASM parser
 shared object.

Package: librust-tree-sitter-asm-dev
Section: rust
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-cc-1+default-dev (>= 1.1.22-~~),
 librust-tree-sitter-language-0.1+default-dev
Provides:
 librust-tree-sitter-asm+default-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0+default-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0.24-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0.24+default-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0.24.0-dev (= ${binary:Version}),
 librust-tree-sitter-asm-0.24.0+default-dev (= ${binary:Version})
Description: ASM grammar for the tree-sitter parser - Rust source code
 tree-sitter-asm is a tree-sitter grammar for ASM.
 .
 Tree-sitter is a parser generator and incremental parsing library.
 .
 This package contains the source for the Rust tree-sitter-asm crate,
 packaged for use with cargo.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_VERSION_UPSTREAM
export TREE_SITTER_SRC_DIR = /usr/src/tree-sitter/asm/${DEB_VERSION_UPSTREAM}/

%:
	dh $@

debian/%: debian/%.in
	sed "s/@PARSER_VER@/$(DEB_VERSION_UPSTREAM)/g" $< > $@

override_dh_auto_build:
	tree-sitter generate --abi $(shell sed -n 's/#define LANGUAGE_VERSION //p' src/parser.c)
	dh_auto_build --buildsystem=rust

# Do not run Makefile install
override_dh_auto_install:
	dh_auto_install --buildsystem=rust

override_dh_install: debian/Makefile
	dh_install

override_dh_auto_test:
	XDG_CACHE_HOME=$(CURDIR)/debian/.cache tree-sitter test
	dh_auto_test --buildsystem=rust

=== debian/tests/control ===
Tests: smoke
Depends: tree-sitter-cli, tree-sitter-asm-src

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-asm 0.24.0 --all-targets --all-features
Features: test-name=rust-tree-sitter-asm:@
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-asm 0.24.0 --all-targets
Features: test-name=librust-tree-sitter-asm-dev:default
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable

Test-Command: /usr/share/cargo/bin/cargo-auto-test tree-sitter-asm 0.24.0 --all-targets --no-default-features
Features: test-name=librust-tree-sitter-asm-dev:
Depends: dh-cargo (>= 31), rustc, librust-tree-sitter-0.25+default-dev (>= 0.25.1-~~), @
Restrictions: allow-stderr, skip-not-installable, flaky

=== debian/watch ===
Version: 5

Source: https://github.com/RubixDev/tree-sitter-asm/tags
Matching-Pattern: .*/v?(\d\S*)@ARCHIVE_EXT@
